import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.util.Date;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import Config;
import Header;

public class StudentSession extends Session{
	
    Header myHeader = new Header();
    String Title="",Head="";
    String Dir=Config.packpath+"/Java_codes/Html_files/";
    public void printPage(Connection Mycon,PrintWriter out,HttpServletRequest Req,String cook){
	// Read from the corresponding form and print back!!!
	    
	try{
	    Integer form_no = new Integer(Req.getParameterValues("form_no")[0]);
	    switch(form_no.intValue()){
		case 0:
		    try{
			Title = "Online Thesis Submission";
		 	Head = "Submission Form";
			myHeader.printHead(Title,Head,out);
			myHeader.printMain(out);
		        Statement Stmt = Mycon.createStatement();
		        String query="select * from students where sroll='"+loginId+"'";
		        ResultSet result=Stmt.executeQuery(query);
		        if(result.next()){
			    this.printUpdatePage(Mycon,out);
		        }
		        else{
		            this.printRespectivePage(Dir+"Studentform1.html",out);
			    this.printTypesList(out,Mycon);
		            this.printRespectivePage(Dir+"Studentform2.html",out);
		        }
		    }catch(SQLException e){}
		    break;
		case 1:
		    System.out.println("I here2");
		    Title = "Online Thesis Submission";
		    Head = "Confirmation";
		    myHeader.printHead(Title,Head,out);
		    this.printRespectivePage(Dir+"Confirmation.html",out);
		    break;
	    }
	} catch(NumberFormatException e){}catch(IOException e){}
    }

    
    
    public void processData(HttpServletRequest Req,Connection Mycon,PrintWriter out){
	// Process the data from the corresponding form!!!
	try{
	    Integer form_no = new Integer(Req.getParameterValues("form_no")[0]);
	    switch(form_no.intValue()){
		case 1:
		    try{
			Statement Stmt=Mycon.createStatement();
			String Query="select * from student_thesis where sroll='"+loginId+"' and type='"+Req.getParameterValues("type")[0]+"'";
			ResultSet result=Stmt.executeQuery(Query);
			if(result.next()){
			     this.upDate(Req,Mycon,out);
			}	
			else{
			     Query="select * from students where sroll='"+loginId+"'";
			     result=Stmt.executeQuery(Query);
			     if(result.next()){
		                  this.insData(Req,Mycon,out,"0");
			     }
			     else{
		                  this.insData(Req,Mycon,out,"1");
			     }	
			}
		    }catch(SQLException e){}
		    break;
	    }
	} catch(NumberFormatException e){}
    }
    
    public void printTypesList(PrintWriter out,Connection Mycon){
	String s="";
	try{
        Statement Stmt=Mycon.createStatement();
	String Query="select type from student_faculty where sroll='"+loginId+"'";
	ResultSet types=Stmt.executeQuery(Query);
	s+="<tr><td><font size=5>Type of Thesis</font></td><td><font size=5><select name=type>";
	while(types.next()){
		s+="<option value="+types.getString(1)+">"+types.getString(1).toUpperCase();
	}
	s+="</select></font></td></tr>";
	out.println(s);
	}catch(SQLException e){}
    }

    
    public void upDate(HttpServletRequest Req,Connection Mycon,PrintWriter out){
	try{
            String type="";
	    String dno="";
	    String year="";
	    String serialno="";
	    Statement Stmt = Mycon.createStatement();	
	    String Name=checkQuote(Req.getParameterValues("name")[0]);
	    String Addr=checkQuote(Req.getParameterValues("addr")[0]);
	    String Email=checkQuote(Req.getParameterValues("email")[0]);
	    type=checkQuote(Req.getParameterValues("type")[0]);
	    String Title=checkQuote(Req.getParameterValues("title")[0]);
	    String KW1=checkQuote(Req.getParameterValues("kw1")[0]);
	    String KW2=checkQuote(Req.getParameterValues("kw2")[0]);
	    String KW3=checkQuote(Req.getParameterValues("kw3")[0]);
	    String KW4=checkQuote(Req.getParameterValues("kw4")[0]);
	    String Abstract=checkQuote(Req.getParameterValues("abstract")[0]);
	    String Stg="update students set sname='"+Name+"',saddress='"+Addr+"',semail='"+Email+"' where sroll='"+loginId+"'";
	    Stmt.executeUpdate(Stg);
	    Stg="select serialno from student_thesis where sroll='"+loginId+"'and type='"+type+"'";
	    ResultSet Result=Stmt.executeQuery(Stg);
	    if(Result.next()){
	        serialno=Result.getString(1);
	    }
	    Stg="select type from student_faculty where sroll='"+loginId+"'";
	    ResultSet Type=Stmt.executeQuery(Stg); 
	    if(Type.next()){
	   	 type=Type.getString(1);
	    }	
	    Stg = "update thesis set title='"+Title+"',keyword1='"+KW1+"',keyword2='"+KW2+"',keyword3='"+KW3+"',keyword4='"+KW4+"',abstract='"+Abstract+"',status='0' where serialno='"+serialno+"'";
	    Stmt.executeUpdate(Stg);
	    Stg="select year from thesis where serialno='"+serialno+"'";
	    ResultSet Year=Stmt.executeQuery(Stg); 
	    if(Year.next()){
	   	 year=Year.getString(1);
	    }	
	    Stg="select dno from auth_table where login='"+loginId+"'";
	    ResultSet Dno=Stmt.executeQuery(Stg); 
	    if(Dno.next()){
	   	 dno=Dno.getString(1);
	    }	
	    Stmt.close();
            String thesisDir=Config.thesispath;
	    File myfile=new File(thesisDir+"/"+dno);
	    myfile.mkdir();
	    myfile=new File(thesisDir+"/"+dno+"/"+year);
	    myfile.mkdir();
	    myfile=new File(thesisDir+"/"+dno+"/"+year+"/"+type);
	    myfile.mkdir();
	    String thesisfile=thesisDir+"/"+dno+"/"+year+"/"+type+"/"+loginId+".html";
	    this.getFile(Req,Mycon,out,thesisfile);
	    this.Mail(loginId,Mycon);
	}catch(SQLException e){}
	catch(IOException e){}
    }
    
    
    public void insData(HttpServletRequest Req,Connection Mycon,PrintWriter out,String Flag)
    throws SQLException{
	try{
	    int newSerialNo=0,curr_date=0;
	    String dno="",type="";
	    Statement Stmt = Mycon.createStatement();	
	    String Name=checkQuote(Req.getParameterValues("name")[0]);
	    String Addr=checkQuote(Req.getParameterValues("addr")[0]);
	    String Email=checkQuote(Req.getParameterValues("email")[0]);
	    type=checkQuote(Req.getParameterValues("type")[0]);
	    String Title=checkQuote(Req.getParameterValues("title")[0]);
	    String KW1=checkQuote(Req.getParameterValues("kw1")[0]);
	    String KW2=checkQuote(Req.getParameterValues("kw2")[0]);
	    String KW3=checkQuote(Req.getParameterValues("kw3")[0]);
	    String KW4=checkQuote(Req.getParameterValues("kw4")[0]);
	    String Abstract=checkQuote(Req.getParameterValues("abstract")[0]);
	    String Stg="select dno from auth_table where login='"+loginId+"'";
	    ResultSet Dno=Stmt.executeQuery(Stg); 
	    if(Dno.next()){
	   	 dno=Dno.getString(1);
	    }	
	    if(Flag.compareTo("1")==0){
	        Stg="insert into students values('"+loginId+"','"+Name+"','"+dno+"','"+Addr+"','"+Email+"')";
	        Stmt.executeUpdate(Stg);
	    }
	    Stg = "select max(serialno) from thesis";
	    ResultSet currSerialNo = Stmt.executeQuery(Stg);
	    if(currSerialNo.next()){
		if(currSerialNo.getString(1) != null){
		    Integer serialNo=new Integer(currSerialNo.getString(1));
		    newSerialNo = serialNo.intValue()+1;
		}
		else{
		    newSerialNo=1;
		}
	    }
	    Date Currdate= new Date();
	    curr_date=Currdate.getYear()+1900;
	    Stg = "insert into thesis values('"+newSerialNo+"','"+Title+"','"+type+"','"+KW1+"','"+KW2+"','"+KW3+"','"+KW4+"','"+loginId+type+"','"+curr_date+"','"+Abstract+"','0')"; Stmt.executeUpdate(Stg);
	    Stg = "insert into student_thesis values('"+newSerialNo+"','"+loginId+"','"+type+"')";
	    Stmt.executeUpdate(Stg);
	    Stmt.close();
            String thesisDir=Config.thesispath;
	    File myfile=new File(thesisDir+"/"+dno);
	    myfile.mkdir();
	    myfile=new File(thesisDir+"/"+dno+"/"+curr_date);
	    myfile.mkdir();
	    myfile=new File(thesisDir+"/"+dno+"/"+curr_date+"/"+type);
	    myfile.mkdir();
	    String thesisfile=thesisDir+"/"+dno+"/"+curr_date+"/"+type+"/"+loginId+".html";
	    this.getFile(Req,Mycon,out,thesisfile);
	    this.Mail(loginId,Mycon);
	}catch(SQLException e){}
	catch(IOException e){}
    }
    
    public void getFile(HttpServletRequest Req,Connection Mycon,PrintWriter out,String thesisfile)
    throws IOException,MalformedURLException,FileNotFoundException{
	// Getting the file specified by url!!
	int readByte,index=0;
	try{
	    String Url = Req.getParameterValues("url")[0];
	    index=Url.indexOf("/",0);	
	        String hostname = Url.substring(0,index);
	        String filename = Url.substring(index);
	        System.out.println("hostname = "+hostname+" ans filename ="+thesisfile);
	        URL myURL = new URL("http",hostname,-1,filename);
	        InputStream myStream = myURL.openStream();
	        FileOutputStream fout = new FileOutputStream(thesisfile);
                DataOutputStream dout = new DataOutputStream(fout);
	        readByte = myStream.read();
	        while(readByte != -1){
		    Character read_Byte = new Character((char)readByte); 
	            dout.writeBytes(read_Byte.toString());	
	            readByte = myStream.read();
	        }
	        dout.close();
	        fout.close();
	} catch(MalformedURLException e){
		Title = "Online Thesis Submission";
		Head = "Alert";
		myHeader.printHead(Title,Head,out);
		this.printRespectivePage(Dir+"filenotfound.html",out);
		out.close();
		}
	 catch(IOException e){
		Title = "Online Thesis Submission";
		Head = "Alert";
		myHeader.printHead(Title,Head,out);
		this.printRespectivePage(Dir+"filenotfound.html",out);
		out.close();
	        }
	 catch(StringIndexOutOfBoundsException e){
		Title = "Online Thesis Submission";
		Head = "Alert";
		myHeader.printHead(Title,Head,out);
		this.printRespectivePage(Dir+"filenotfound.html",out);
		out.close();
	         }
    }
	
    
    public void printRespectivePage(String Filename,PrintWriter out)
    throws FileNotFoundException,IOException{
	// Open the file with name Filename and just print the contents of it!! 
	try{
	    System.out.println("I in printrespage and file name="+Filename);
            FileInputStream file = new FileInputStream(Filename);
	    InputStreamReader reader = new InputStreamReader(file);
	    BufferedReader input = new BufferedReader(reader);
	    String nextLine;
	    while((nextLine=input.readLine())!=null){
	        out.println(nextLine);
	    }
	    input.close();
	    reader.close();
	    file.close();
	} catch(FileNotFoundException e){}
    }
    String checkQuote(String initString){
	String returnString="";
        try{
	int beginindex=0,endindex=0;
	for(;;){
	    endindex=initString.indexOf("'",beginindex);
	    if(endindex==-1){
		returnString+=initString.substring(beginindex);
		break;
	    }
	    else{
		returnString+=initString.substring(beginindex,endindex)+"''";
		beginindex=endindex+1;
	    }
    	}
	} catch(StringIndexOutOfBoundsException e){}
	return(returnString);
    }	

    public void printUpdatePage(Connection Conn,PrintWriter out){
	String serialno="";
	try{
	Statement Stmt=Conn.createStatement();
String s="<center> <table> <tr><td> <font size=5> Name </font> </td><td> <font size=5> <input type=text size=30 name=name value=";
String Query="select sname from students where sroll='"+loginId+"'";
ResultSet Result=Stmt.executeQuery(Query);
if(Result.next()){
s+="\""+Result.getString(1)+"\"";
}
s+="> </font> </td> </tr> <tr><td> <font size=5> Address </font> </td><td> <font size=5> <input type=text size=30 name=addr value=";
Query="select saddress from students where sroll='"+loginId+"'";
Result=Stmt.executeQuery(Query);
if(Result.next()){
s+="\""+Result.getString(1)+"\"";
}
s+="> </font> </td> </tr> <tr><td> <font size=5> Email </font> </td><td> <font size=5> <input type=text size=30 name=email value=";
Query="select semail from students where sroll='"+loginId+"'";
Result=Stmt.executeQuery(Query);
if(Result.next()){
s+="\""+Result.getString(1)+"\"";
}
s+="> </font> </td> </tr>";
out.println(s);
this.printTypesList(out,Conn);
s="<tr><td> <font size=5> Thesis Title </font> </td><td> <font size=5> <input type=text size=30 name=title value=";
Query="select serialno from student_thesis where sroll='"+loginId+"'";
Result=Stmt.executeQuery(Query);
if(Result.next()){
serialno=Result.getString(1);
}
Query="select title from thesis where serialno='"+serialno+"'";
Result=Stmt.executeQuery(Query);
if(Result.next()){
s+="\""+Result.getString(1)+"\"";
}
s+="> </font> </td> </tr> <tr><td> <font size=5> Url of File </font> </td><td> <font size=5> <input type=text size=30 name=url value=\"\"> </font> </td> </tr> <tr><td></td> <td> <font size=5> (Eg : www.cse.iitb.ernet.in/~gsiva/Report.ps) </font> </td> </tr> </table> </center> <center> <table> <tr><td> <font size=5> Keywords </font> </td><td> <font size=5> <input type=text size=15 name=kw1 value=";
Query="select keyword1,keyword2,keyword3,keyword4,abstract from thesis where serialno='"+serialno+"'";
Result=Stmt.executeQuery(Query);
if(Result.next()){
s+="\""+Result.getString(1)+"\"";
s+="> </font> </td><td> <font size=5> <input type=text size=15 name=kw2 value=";
s+="\""+Result.getString(2)+"\"";
s+="> </font> </td> <tr><td></td><td> <font size=5> <input type=text size=15 name=kw3 value=";
s+="\""+Result.getString(3)+"\"";
s+="> </font> </td> <td> <font size=5> <input type=text size=15 name=kw4 value=";
s+="\""+Result.getString(4)+"\"";
s+="> </font> </td> </tr> </table> </center> <hr> <center><u> <font size=5> Abstract of Thesis </u> </font> </center> <center> <font size=4> ( * Abstract should not be more than <i>200</i> words) </font> </center> <center> <font size=5> <textarea rows=12 cols=60 name=abstract>";
s+=Result.getString(5);
}
s+="</textarea> </font> </center> <hr> <center> <table> <tr><td> <font size=5> <input type=submit value=ENTER></font></td> <td> <font size=5> <input type=reset value=RESET></font></td> </tr> </table> </center> <input type=hidden name=form_no value=1> </form> </body> </html>";
    out.println(s);
	} catch(SQLException e){}
    }

    
    void Mail(String rollno,Connection con){

    // Use for mailing the facult about the submission of thesis by a
    // student under him 
	System.out.println("I 1hereasloqerw4er34t45");

	try{
	Statement stmt=con.createStatement();
	String str="select faculty.femail,faculty.fname,students.sname from faculty,students,student_faculty where students.sroll=student_faculty.sroll and faculty.loginid=student_faculty.loginid and students.sroll='"+rollno+"'";

   // finding the email address and name of the guide and coguide given the
   // rollno of the student.

	ResultSet rset1=stmt.executeQuery(str);
	System.out.println("I 2hereasloqerw4er34t45");
	while(rset1.next()){
		String femail=rset1.getString(1);
		String fname=rset1.getString(2);
		String sname=rset1.getString(3);
		String body="Prof. "+fname+",\n The following student of";
		body+=" yours has submitted his thesis : \n\n Name : "+sname;
		body+="\n Rollno : "+rollno+"\n\n Kindly approve it.";

		System.out.println("I hereasloqerw4er34t45");
		Mailer faculty=new Mailer(femail,body);
		faculty.start();
	}
	} catch(SQLException e){}
    }	
}
